import { ITimerParams } from "./interfaces/i-timer-params";
import { BusinessDay } from "./interfaces/i-business-day";
import WorkingTimeout from "./working-timeout";
export declare class Timer {
    private bufferedCalendar;
    private timerValidator;
    private timerParams;
    private minBufferedDate;
    private maxBufferedDate;
    constructor();
    setConfig(timerParams: ITimerParams): Timer;
    setConfigAsync(timerParams: ITimerParams): Promise<Timer>;
    private constructWorkingDays;
    private addToBuffer;
    readonly getBufferedCalendar: Map<string, BusinessDay>;
    getDayInfo(date: Date): BusinessDay;
    getDayInfoAsync(date: Date): Promise<BusinessDay>;
    workingTimeBetween(from: Date, to: Date, unit: 'MINUTES' | 'HOURS' | 'DAYS'): Number;
    workingTimeBetweenAsync(from: Date, to: Date, unit: 'MINUTES' | 'HOURS' | 'DAYS'): Promise<Number>;
    isWorkingTime(date: Date): boolean;
    isWorkingTimeAsync(date: Date): Promise<boolean>;
    getNextWorkingTime(date: Date): Date;
    getNextWorkingTimeAsync(date: Date): Promise<Date>;
    getPreviousWorkingTime(date: Date): Date;
    getPreviousWorkingTimeAsync(date: Date): Promise<Date>;
    getNextWorkingDay(date: Date): Date;
    getNextWorkingDayAsync(date: Date): Promise<Date>;
    getPreviousWorkingDay(date: Date): Date;
    getPreviousWorkingDayAsync(date: Date): Promise<Date>;
    add(date: Date, duration: number, unit: 'MINUTES' | 'HOURS' | 'DAYS'): Date;
    addAsync(date: Date, duration: number, unit: 'MINUTES' | 'HOURS' | 'DAYS'): Promise<Date>;
    setWorkingTimeout(baseDate: Date, duration: number, unit: 'MINUTES' | 'HOURS' | 'DAYS', cb: Function, desc: string): WorkingTimeout;
    setWorkingTimeoutAsync(baseDate: Date, duration: number, unit: 'MINUTES' | 'HOURS' | 'DAYS', cb: Function, desc: string): Promise<WorkingTimeout>;
}
