"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var WorkingTimeout = (function () {
    function WorkingTimeout(_baseDate, _fireDate, _duration, _timeUnit, _callback, _description) {
        this._baseDate = _baseDate;
        this._fireDate = _fireDate;
        this._duration = _duration;
        this._timeUnit = _timeUnit;
        this._callback = _callback;
        this._description = _description;
        this._fired = false;
        this._cancelled = false;
        this.timeoutMs = this._fireDate.getTime() - Date.now();
        this.initTimeout();
    }
    WorkingTimeout.prototype.initTimeout = function () {
        var _this = this;
        this.timeoutID = setTimeout(function () {
            _this._fired = true;
            _this._callback();
        }, this.timeoutMs);
    };
    WorkingTimeout.prototype.clearTimeout = function () {
        this._cancelled = true;
        clearTimeout(this.timeoutID);
    };
    Object.defineProperty(WorkingTimeout.prototype, "baseDate", {
        get: function () {
            return this._baseDate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WorkingTimeout.prototype, "fireDate", {
        get: function () {
            return this._fireDate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WorkingTimeout.prototype, "duration", {
        get: function () {
            return this._duration;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WorkingTimeout.prototype, "description", {
        get: function () {
            return this._description;
        },
        set: function (value) {
            this._description = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WorkingTimeout.prototype, "callback", {
        get: function () {
            return this._callback;
        },
        set: function (value) {
            this._callback = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WorkingTimeout.prototype, "timeUnit", {
        get: function () {
            return this._timeUnit;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WorkingTimeout.prototype, "fired", {
        get: function () {
            return this._fired;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WorkingTimeout.prototype, "cancelled", {
        get: function () {
            return this._cancelled;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WorkingTimeout.prototype, "remainingTime", {
        get: function () {
            return this._fireDate.getTime() - Date.now();
        },
        enumerable: true,
        configurable: true
    });
    return WorkingTimeout;
}());
exports.default = WorkingTimeout;
